/*******************************<+>***************************
 **                             PRC
 *************************************************************
 **
 **  $Id: Font.c,v 1.3 1993/12/22 01:45:25 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Font.c,v $
 **
 **  Module Name:
 **
 **  Classification:  Unclassified
 **
 **  Author:          Dale T. Anderson
 **
 *******************************<+>***************************/

#include <stdio.h>
#include <string.h>
#include <signal.h>

#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>

#include "Xn.h"

static void     traverse_tree (w, list)
Widget          w;
XmFontList     *list;
{
    Window          root;
    Window          parent;
    Window         *children;
    int             nchildren;
    int             i;

    XtVaSetValues (w,
		   XmNfontList, list,
		   NULL);

    XQueryTree (XtDisplay (w), XtWindow (w), &root, &parent, &children, &nchildren);

    for (i = 0; i < nchildren; i++) {
	traverse_tree (XtWindowToWidget (XtDisplay (w), children[i]), list);
    }
    if (nchildren)
	XFree ((char *) children);
}

void            XnDisplayFont (w, data, reason)
Widget          w;
char           *data;
int            *reason;
{
    XFontStruct    *font;
    XmFontList      fontlist;
    Dimension       width;
    Dimension       height;
    double          scalex;
    double          scaley;
    extern Widget xntop;

    if ((font = XLoadQueryFont (XtDisplay (xntop), data))) {
	XtVaGetValues (xntop,
	    XmNwidth, width,
	    XmNheight, height,
	    NULL);
	    
	scalex = 1.0;
	scaley = 1.0;

	fontlist = XmFontListCreate (font, "charset1");
	traverse_tree (xntop, fontlist);

	width = (Dimension) (scalex * width);
	height = (Dimension) (scaley * height);

/*
	XtVaSetValues (xntop,
	    XmNwidth, width,
	    XmNheight, height,
	    NULL);
	    */
    }
}

static XnCallbackData def_menu[] = {
    {NULL, "Tiny Font", (XtCallbackProc) XnDisplayFont, "5x8"},
    {NULL, "Small Font", (XtCallbackProc) XnDisplayFont, "6x10"},
    {NULL, "Medium Font", (XtCallbackProc) XnDisplayFont, "8x13"},
    {NULL, "Large Font", (XtCallbackProc) XnDisplayFont, "9x15"},
    {NULL, NULL, NULL, NULL},
    {NULL, "Print", NULL, NULL},
    {NULL, NULL, NULL, NULL},
    {NULL, "Exit", (XtCallbackProc) XnExit, NULL},
    NULL
};

void     XnInitFontMenu (title, top, proc, data)
char           *title;
Widget          top;
XtCallbackProc  proc;
XtPointer       data;
{
    extern Widget xntop;

    def_menu[XtNumber (def_menu) - 1].proc = proc;
    def_menu[XtNumber (def_menu) - 1].data = data;

    XnCreatePopupMenu (xntop, def_menu);
}
