/*******************************<+>***************************
 **                             PRC
 *************************************************************
 **
 **  $Id: Initialize.c,v 1.8 1993/12/22 01:45:26 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Initialize.c,v $
 **
 **  Module Name:
 **
 **  Classification:  Unclassified
 **
 **  Author:          Dale T. Anderson
 **
 *******************************<+>***************************/

#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <sys/wait.h>

#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>

#include "Xn.h"

Widget   xntop;
XtAppContext   _xnapp;

char *argv0;

void            XnExit (status)
int             status;
{
    XtCloseDisplay (XtDisplay (xntop));
    _exit (0);
}

static void            _exit_cb (w, data, cb)
Widget          w;
XtPointer      *data;
XtPointer      *cb;
{
    XnExit (0);
}

static void     _handle_signal (sig)
int             sig;
{
    (void) signal (SIGSEGV, (void (*) ()) SIG_DFL);
#ifdef SIGBUS
    (void) signal (SIGBUS, (void (*) ()) SIG_DFL);
#endif
    (void) signal (SIGFPE, (void (*) ()) SIG_DFL);
    (void) signal (SIGILL, (void (*) ()) SIG_DFL);
#ifdef SIGEMT
    (void) signal (SIGEMT, (void (*) ()) SIG_DFL);
#endif

    (void) fprintf (stderr, "%s caught signal %d...\n", argv0, sig);
    XnExit (sig);
}

static void _handle_child (int sig)
{
    pid_t pid;
    int stat_loc;

    while ((pid = wait3 (&stat_loc, WNOHANG, NULL)) > 0)
	;

    signal (sig, _handle_child);
}

static void     doit (title, top, proc, data)
char           *title;
Widget          top;
XtCallbackProc  proc;
XtPointer       data;
{
    if (strrchr (argv0, '/'))
	argv0 = strrchr (argv0, '/') + 1;

    printf ("%s - %s\n", argv0, "V1.0");

    if (!proc) {
	proc = _exit_cb;
    }

    XnSetFrameClose (xntop, proc, data);

    (void) signal (SIGSEGV, _handle_signal);
#ifdef SIGBUS
    (void) signal (SIGBUS, _handle_signal);
#endif
    (void) signal (SIGILL, _handle_signal);
#ifdef SIGEMT
    (void) signal (SIGEMT, _handle_signal);
#endif
    (void) signal (SIGHUP, _handle_signal);
    (void) signal (SIGQUIT, _handle_signal);
    (void) signal (SIGTERM, XnExit);
    (void) signal (SIGINT, XnExit);
    (void) signal (SIGCLD, _handle_child);
    (void) signal (SIGIOT, _handle_child);
}

Widget          XnAppInitialize (title, app, argc, argv, proc, data)
char           *title;
XtAppContext   *app;
int            *argc;
char          **argv;
XtCallbackProc  proc;
XtPointer       data;
{
    xntop = XtVaAppInitialize (app, "Nites",
			       NULL, NULL,
			       argc, argv, NULL,
			       XmNtitle, title,
			       XmNx, 100,
			       XmNy, 100,
			       NULL);
    argv0 = argv[0];
    doit (title, xntop, proc, data);
    _xnapp = *app;
    return xntop;
}
