/*******************************<+>***************************
 **                             DTA
 *************************************************************
 **
 **  $Id: Prompt.c,v 1.5 1994/02/18 19:56:21 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Prompt.c,v $
 **
 **  What @(#):
 **
 **  Author: Dale T. Anderson
 **
 *******************************<+>***************************/
 
#include <stdarg.h>

#include <Xm/Xm.h>
#include <Xm/MessageB.h>

#include <Xn/Xn.h>

extern XtAppContext _xnapp;
extern Widget xntop;

static int button = False;

#define YES_BUTTON 1
#define NO_BUTTON  0

static void prompt_cb(w, b, cb)
Widget w;
int b;
XmAnyCallbackStruct *cb;
{
    button = b;
    XnPopdown (w);
}

int XnPromptYesNo (const char *fmt, ...)
{
    static Widget dialog = NULL;
    char buffer [1024];
    va_list args;

    va_start (args, fmt);
    vsprintf (buffer, fmt, args);
    va_end (args);

    if (!dialog) {
	dialog = XmCreateQuestionDialog(xntop, "question_dialog", NULL, 0);
	XnWidgtePutStr (XtParent (dialog), "Prompt");

	XnWidgetPutStr (XmMessageBoxGetChild(dialog, XmDIALOG_OK_BUTTON), "Yes");
	XnWidgetPutStr (XmMessageBoxGetChild(dialog, XmDIALOG_CANCEL_BUTTON), "No");

	XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_HELP_BUTTON));

	XnAddCallback(XtParent(dialog), XmNpopdownCallback, prompt_cb, False);

	XnAddCallback(dialog, XmNokCallback, prompt_cb, True);
	XnAddCallback(dialog, XmNcancelCallback, prompt_cb, False);
    }

    XtManageChild(dialog);
    XtPopup (XtParent (dialog), XtGrabNone);

    XnWidgetPutStr (dialog, buffer);

    button = -1;

    while (button == -1) {
	XEvent event;

	XtAppNextEvent(_xnapp, &event);
	XtDispatchEvent(&event);
    }

    return button;
}
