/*******************************<+>***************************
 **                             DTA
 *************************************************************
 **
 **  $Id: Xn.h,v 1.7 1994/02/18 19:56:26 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Xn.h,v $
 **
 **  What @(#):
 **
 **  Author: Dale T. Anderson
 **
 *******************************<+>***************************/
 
#ifndef _Xn_h
#define _Xn_h

#ifdef __cplusplus 
extern "C" {
#endif

#include <assert.h>
#include <Xm/Xm.h>

#define XnAddCallback(w, cb, proc, ptr) \
	XtAddCallback (w, cb, (XtCallbackProc)(proc), (XtPointer)(ptr))

typedef struct {
    Widget          w;
    char           *name;
    XtCallbackProc  proc;
    XtPointer       data;
}               XnCallbackData;

typedef struct {
    XnCallbackData  cbd;
    char *accelerator;
    char *accel_text;
    char *comment;
    int mask;
}               XnMenuData;

typedef struct {
    Pixmap pixmap;
    Dimension width;
    Dimension height;
}               XnPixmapData;

typedef struct {
    double          h;
    double          s;
    double          v;
}               XnHSVColor;

typedef struct {
    XnHSVColor beg;
    XnHSVColor end;
    int count;
    XColor *colors;
} XnHSVBand;

typedef struct {
    int rows;
    int cols;
    XnHSVBand **bands;
} XnHSVGrid;

typedef struct {
    Colormap cmap;
    int count;
    Pixel *pixels;
} XnColormapData;

typedef struct {
    int turnon;
    int reason;
    int button;
    XEvent *event;
    GC xorgc;
    int x1;
    int y1;
    int x2;
    int y2;
} XnRubberCallbackStruct;

extern char *version_string;

typedef struct _XnColorRequest {
    /*
    * Set these fields to make a request.
    */
    String      color_name;     /* Name of color to allocate or match */
    unsigned short red;         /* RGB values to allocate or match if String
    == NULL or "" */
    unsigned short green;
    unsigned short blue;
    Pixel      *addr;           /* Address to store Pixel into */
    int         priority;       /* If priorities are the same then reqs are s
    orted by min_dist */
    /*
    * These are for internal use.
    */
    Boolean     allocated;      /* True if allocated in the first pass */
    double      min_dist;       /* Min dist between hw color and available co
    lor in cmap */
    Pixel       closest;        /* Closest Pixel to color_name */
} XnColorRequest;

#include <Xn/Dictionary.h>
#include <Xn/Xnlib.h>

#ifdef __cplusplus 
}
#endif

#endif
